package spacewar;

import java.util.Enumeration;
import java.util.Vector;

public  aspect DisplayAspect {

	   private static Vector DISPLAYS = new Vector(2);
	
	Object pilot1, pilot2;
	
    after (String mode) returning (Game game): call(Game+.new(String)) && args(mode) {
        new Display1(game);
        new Display2(game);

        if ( mode.equals("1") ) {
            pilot1 = game.newPlayer(1);
        }
        else if ( mode.equals("2") ) {
            pilot1 = game.newPlayer(1);
            pilot2 = game.newPlayer(2);
        }
        else if (mode. equals("demo")) {
            pilot1 = game.newRobot(1);
            pilot2 = game.newRobot(2);
        } else {
            game.error("Invalid mode: " + mode);
            game.quit();
        }
    }


    /*
     * I'm not really sure this belongs here.
     *
     * Being here what it does is makes the Display aspect
     * responsible for having the Players couple up to it.  That's
     * kind of nice, but its a bit incomplete, since Player is
     * really part of the GUI, not part of the core Game.
     *
     * In a future re-factoring this will get worked out better.
     * What will happen is that GUI will be an aspect that has the
     * core GUI.  Each of the different kinds of displays will be
     * aspects that tie themselves in.
     */
    after () returning (Player player): call(Player+.new(..)) {
        Enumeration elements = DISPLAYS.elements();
        while ( elements.hasMoreElements() ) {
            Display display = (Display)elements.nextElement();
            display.addKeyListener(player);
        }
    }

    after() returning (Display display): call(Display+.new(..)) {
        display.noticeSizeChange();
    }

    after(Display display) returning (): call(void setSize(..)) && target(display) {
        display.noticeSizeChange();
    }

    after() returning : call(void Game.clockTick()) {
        Enumeration elements = DISPLAYS.elements();
        while ( elements.hasMoreElements() ) {
            Display display = (Display)elements.nextElement();
            display.repaint();
        }
    }
}